/**
 * This script is generated by I Maker
 * DO NOT MODIFY!
 */

class IMariaDBHandlerPool {
  static bool _initialized = false;
  static IMariaDBHandlerPool _instance;

  static final Map dbs = <String, List<ConnectionPool>>{};
  static final Map nodesLength = <String, int>{};

  void init(Map config) {
    config.forEach((String groupName, List group) {
      // get groupName
      dbs[groupName] = new List(group.length);
      nodesLength[groupName] = group.length;

      // for nodes
      group.forEach((Map node) {
        _checkNodeConfig(node);

        dbs[groupName][node['no']] = new ConnectionPool(
            host: node['host'],
            port: node['port'],
            user: node['usr'],
            password: node['pwd'],
            db: node['db'],
            max: node['maxHandler']
        );
      });
    });
    _initialized = true;
  }

  factory IMariaDBHandlerPool() {
    if (_instance is IMariaDBHandlerPool) return _instance;
    _instance = new IMariaDBHandlerPool._internal();
    return _instance;
  }

  IMariaDBHandlerPool._internal();

  static void _checkNodeConfig(node) {
    // check node config
    if (!node.containsKey('no')) throw new IStoreException(21001);
    if (!node.containsKey('host')) throw new IStoreException(21002);
    if (!node.containsKey('port')) throw new IStoreException(21003);
    if (!node.containsKey('pwd')) throw new IStoreException(21004);
    if (!node.containsKey('db')) throw new IStoreException(21005);
    if (!node.containsKey('usr')) throw new IStoreException(21006);
    if (!node.containsKey('maxHandler')) throw new IStoreException(21007);
  }

  ConnectionPool getWriteHandler(Map store, shardKey) {
    _checkInitialized();

    String groupType = 'master';
    String groupName = store[groupType];

    int modValue = nodesLength[groupName];
    int shardIndex = _getShardIndex(store['shardMethod'], shardKey, modValue);

    return dbs[groupName][shardIndex];
  }

  ConnectionPool getReaderHandler(Map store, shardKey) {
    _checkInitialized();

    String groupType = store['readWriteSeparate'] ? 'slave' : 'master';
    String groupName = store[groupType];

    int modValue = nodesLength[groupName];
    int shardIndex = _getShardIndex(store['shardMethod'], shardKey, modValue);

    return dbs[groupName][shardIndex];
  }

  void _checkInitialized() {
    if (!_initialized) throw new IStoreException(21029);
  }

  int _getShardIndex(String shardMethod, shardKey, num modValue) {
    int shardIndex;
    switch (shardMethod) {
      case 'NONE':
        shardIndex = 0;
        break;
      case 'CRC32':
        shardIndex = CRC32.compute(shardKey.toString()) % modValue;
        break;
      default:
        throw new IStoreException(21040);
    }
    return shardIndex;
  }
}
